<!DOCTYPE html>
<html>
  <head>
    <title>Task62</title>
    <meta charset="utf-8">
    <meta name="viewport" content="width=device-width, initial-scale=1">
    <link rel="stylesheet" href="https://maxcdn.bootstrapcdn.com/bootstrap/4.5.2/css/bootstrap.min.css">
    <script src="https://ajax.googleapis.com/ajax/libs/jquery/3.5.1/jquery.min.js"></script>
    <script src="https://maxcdn.bootstrapcdn.com/bootstrap/4.5.2/js/bootstrap.min.js"></script>

    <!-- Import Datatable sau jquery -->
    <!-- Import them style bootstrap cho datatable -->
    <link rel="stylesheet" href="https://cdn.datatables.net/1.10.24/css/dataTables.bootstrap4.min.css">
    <script src="https://cdn.datatables.net/1.10.24/js/jquery.dataTables.min.js"></script>
    <script src="https://cdn.datatables.net/1.10.24/js/dataTables.bootstrap4.min.js"></script>
  </head>

<body>
  <div class="container">
    <h2>Responsive Form</h2>
    <h4>Province - District - Ward Select</h4>

    <form id="inputform01" class="jumbotron container">
      
      <div class="row form-group">
        <div class="col-sm-3">
          <label for="province">Tỉnh thành phố</label>
        </div>
        <div class="col-sm-3">
          <select id="province-select" name="province" class="form-control">
          </select>
        </div>
      </div>
      <div class="row form-group">
        <div class="col-sm-3">
          <label for="district">Quận huyện</label>
        </div>
        <div class="col-sm-3">
          <select id="district-select" disabled="" name="district" class="form-control">
          </select>
        </div>
      </div>
      <div class="row form-group">
        <div class="col-sm-3">
          <label for="ward">Phường Xã</label>
        </div>
        <div class="col-sm-3">
          <select id="ward-select" disabled="" name="ward" class="form-control">
          </select>
        </div>
      </div>
      <div class="row pull-right">
        <div class="col-sm-12">
          <input type="button" value="Send" class="btn btn-info" id="send-button">
        </div>
      </div>
    </form>
  </div>
  <script>
    //Get data province
    $.ajax({
      url: "http://localhost:8080/provinces",
      method: "GET",
      success: function(pObjRes) {
        console.log(pObjRes);
        loadDataToProvinceSelect(pObjRes);
      },
      error: function(paramErr) {
        console.log(paramErr.responseText);
      }
    });

    var gProvinceSelectElement = $("#province-select");

    function loadDataToProvinceSelect(pProvinceList) {
      for (i = 0; i < pProvinceList.length; i++) {
        var bProvinceOption = $("<option/>");
        bProvinceOption.prop("value", pProvinceList[i].id);
        bProvinceOption.prop("text", pProvinceList[i].name);
        gProvinceSelectElement.append(bProvinceOption);
      };
    }

    var gDistrictSelectElement = $("#district-select");

    //callback function
    gProvinceSelectElement.on("change", function () {
    gDistrictSelectElement.html("");
    var bProvinceId = $(this).val();

    getDistrictsByProvinceId(bProvinceId);
    });

    //find district array by provinceId
    function getDistrictsByProvinceId(pProvinceId) {
      $.ajax({
        url: "http://localhost:8080/districts?provinceId=" + pProvinceId,
        method: "GET",
        success: function(pObjRes) {
          console.log(pObjRes);
          loadDataToDistrictSelect(pObjRes);
        },
        error: function(paramErr) {
          console.log(paramErr.responseText);
        }
      });
    }

    function loadDataToDistrictSelect(pDistrictList) {
      if (pDistrictList.length > 0) {
        gDistrictSelectElement.prop("disabled", false);

        for (i = 0; i < pDistrictList.length; i++) {
          var bDistrictOption = $("<option/>");
          bDistrictOption.prop("value", pDistrictList[i].id);
          bDistrictOption.prop("text", pDistrictList[i].name);
          gDistrictSelectElement.append(bDistrictOption);
        };
      } else {
        gDistrictSelectElement.prop("disabled", "disabled");
      }
    }
    //subtask 9
    var gWardSelectElement = $("#ward-select");
    //xử lý sk on change
    gDistrictSelectElement.on("change", function () {
    gWardSelectElement.html("");
    var bDistrictId = $(this).val();

    getWardsByDistrictId(bDistrictId);
    });

    //find ward array by districtId
    function getWardsByDistrictId(pDistrictId) {
      $.ajax({
        url: "http://localhost:8080/wards?districtId=" + pDistrictId,
        method: "GET",
        success: function(pObjRes) {
          console.log(pObjRes);
          loadDataToWardSelect(pObjRes);
        },
        error: function(paramErr) {
          console.log(paramErr.responseText);
        }
      });
    }

    function loadDataToWardSelect(pWardList) {
      if (pWardList.length > 0) {
        gWardSelectElement.prop("disabled", false);

        for (i = 0; i < pWardList.length; i++) {
          var bWardOption = $("<option/>");
          bWardOption.prop("value", pWardList[i].id);
          bWardOption.prop("text", pWardList[i].name);
          gWardSelectElement.append(bWardOption);
        };
      } else {
        gWardSelectElement.prop("disabled", "disabled");
      }
    }
  </script>

</body>
</html>
